//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%45A2B55D007E.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%45A2B55D007E.cm

//## begin module%45A2B55D007E.cp preserve=no
//## end module%45A2B55D007E.cp

//## Module: EDFVariants%45A2B55D007E; Package body
//## Subsystem: XSFit::StatMethod::EDF%45A2A53C02B8
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/StatMethod/EDF/EDFVariants.cxx

//## begin module%45A2B55D007E.additionalIncludes preserve=no
//## end module%45A2B55D007E.additionalIncludes

//## begin module%45A2B55D007E.includes preserve=yes
//## end module%45A2B55D007E.includes

// EDFVariants
#include <XSFit/StatMethod/EDF/EDFVariants.h>
//## begin module%45A2B55D007E.declarations preserve=no
//## end module%45A2B55D007E.declarations

//## begin module%45A2B55D007E.additionalDeclarations preserve=yes
#include <XSUtil/Error/Error.h>
#include <cmath>
#include <XSstreams.h>
//## end module%45A2B55D007E.additionalDeclarations


// Class K_S 

//## begin K_S::fullName%45A2B6ED0377.attr preserve=no  public: static const string {U} string("Kolmogorov-Smirnov")
const string K_S::fullName = string("Kolmogorov-Smirnov");
//## end K_S::fullName%45A2B6ED0377.attr

//## begin K_S::scriptName%45A2B88B0189.attr preserve=no  public: static const string {U} string("Kolmogorov-Smirnov")
const string K_S::scriptName = string("Kolmogorov-Smirnov");
//## end K_S::scriptName%45A2B88B0189.attr


//## Other Operations (implementation)
Real K_S::calculate (const RealArray& EDF, const RealArray& modelDF, const Real totalCounts)
{
  //## begin K_S::calculate%45A50BBE0075.body preserve=yes
   const RealArray difference(std::abs(EDF-modelDF));
   Real result = difference.max();
   return result;
  //## end K_S::calculate%45A50BBE0075.body
}

// Class C_vM 

//## begin C_vM::fullName%45A66C7F02AD.attr preserve=no  public: static const string {U} string("Cramer-von Mises")
const string C_vM::fullName = string("Cramer-von Mises");
//## end C_vM::fullName%45A66C7F02AD.attr

//## begin C_vM::scriptName%45A66C85035D.attr preserve=no  public: static const string {U} string("Cramer-von Mises")
const string C_vM::scriptName = string("Cramer-von Mises");
//## end C_vM::scriptName%45A66C85035D.attr


//## Other Operations (implementation)
Real C_vM::calculate (const RealArray& EDF, const RealArray& modelDF, const Real totalCounts)
{
  //## begin C_vM::calculate%45A66C6701D0.body preserve=yes
   // Calculate (F_n(x) - F(x))^2*dF(x)
   RealArray difference(EDF);
   difference -= modelDF;
   difference *= difference;
   // And now the dF(x) term...
   Real prev = 0.0;
   const size_t sz = modelDF.size();
   for (size_t i=0; i<sz; ++i)
   {
      Real dF = modelDF[i] - prev;
      difference[i] *= dF;
      prev = modelDF[i]; 
   }
   return difference.sum();
  //## end C_vM::calculate%45A66C6701D0.body
}

// Class A_D 

//## begin A_D::fullName%45A66E210196.attr preserve=no  public: static const string {U} string("Anderson-Darling")
const string A_D::fullName = string("Anderson-Darling");
//## end A_D::fullName%45A66E210196.attr

//## begin A_D::scriptName%45A66E27008E.attr preserve=no  public: static const string {U} string("Anderson-Darling")
const string A_D::scriptName = string("Anderson-Darling");
//## end A_D::scriptName%45A66E27008E.attr


//## Other Operations (implementation)
Real A_D::calculate (const RealArray& EDF, const RealArray& modelDF, const Real totalCounts)
{
  //## begin A_D::calculate%45A66E2E0035.body preserve=yes
   // Calculate (F_n(x) - F(x))^2*dF(x)/(F(x)*|(1 - F(x))|)
   RealArray difference(EDF);
   difference -= modelDF;
   difference *= difference;
   Real prev = 0.0;
   const size_t sz = modelDF.size();
   for (size_t i=0; i<sz; ++i)
   {
      Real dF = modelDF[i] - prev;
      difference[i] *= dF;
      prev = modelDF[i]; 
   }
   RealArray weight(modelDF);
   weight -= 1.0;
   weight = abs(weight);
   weight *= modelDF;
   Real result=0.0;
   const Real* pDiff = &difference[0];
   const Real* pWeight = &weight[0];
   for (size_t i=0; i<sz; ++i)
   {
      if (pWeight[i] != 0.0)
      {
         result += pDiff[i]/pWeight[i];
      }
   }
   return result;
   
  //## end A_D::calculate%45A66E2E0035.body
}

//## begin module%45A2B55D007E.epilog preserve=yes
//## end module%45A2B55D007E.epilog
